define({"0":{y:0,u:"../started/xap-basics.html",l:-1,t:"Data Grid Basics",i:0.000541785545720991,a:"Smart Cache Smart DIH Data Grid Basics This section provides some hands-on examples to demonstrate the core concepts and APIs of the GigaSpaces in-memory data grid. The tutorials are geared toward architects and developers who want to build scaled-out applications with GigaSpaces.  "},"1":{y:0,u:"../started/xap-ide.html",l:-1,t:"Preparing Your Development Environment",i:0.000365918342101923,a:"Smart Cache Preparing Your Development Environment \nFollow the instructions in this tutorial to set up your IDE so you can begin to work with GigaSpaces products. If you are working in a Kubernetes environment, you will be able to prepare a Docker from your code and add deployment .yaml\u0027s to it in ..."},"2":{y:0,u:"../started/installation-maven-overview.html",l:-1,t:"Maven Artifacts",i:0.0122439379050606,a:"Smart Cache Maven Artifacts Maven is a tool used to automate and simplify the development cycle of any Java-based project. The GigaSpaces plugin for Maven utilizes Maven to simplify the development cycle of GigaSpaces-based applications. This section describes the  Maven artifacts that are provided, ..."},"3":{y:0,u:"../started/maven-artifacts.html",l:-1,t:"Maven Artifacts",i:0.000365918342101923,a:"GigaSpaces is Maven-friendly. It is built using Maven and is designed to be easily used by developers constructing GigaSpaces applications. In this page we\u0027ll explain how to use GigaSpaces with Maven. GigaSpaces Maven Repository GigaSpaces artifacts are not currently published in the Maven Central ..."},"4":{y:0,u:"../started/installation-maven.html",l:-1,t:"Maven Plugin",i:0.00450364198507068,a:"Maven is a tool used to automate and simplify the development cycle of any Java-based project. The GigaSpaces plugin for Maven utilizes Maven to simplify the development cycle of GigaSpaces-based applications. You can use this plugin to easily create, compile, package, run unit tests, execute and ..."},"5":{y:0,u:"../started/installation-maven-advanced.html",l:-1,t:"Advanced Configuration",i:0.000365918342101923,a:"This page contains information beyond the basics. It was created for those who want to know a little bit more about how GigaSpaces and Maven integrate. Basically, the information given in  GigaSpaces Maven Plugin  should be sufficient for the common user. Processing Unit Assembly Definition The ..."},"6":{y:0,u:"../started/xap-in-5-minutes.html",l:-1,t:"GigaSpaces in 5 Minutes",i:0.000365918342101923,a:"This tutorial explains how to deploy and use a GigaSpaces Data Grid  from a Java client application. Starting a Service Grid A Data Grid requires a  Service Grid  to host it. A service grid is composed of one or more machines (service grid nodes) running a  Service Grid Agent  (or GSA), and provides ..."},"7":{y:0,u:"../started/xap-tutorial-part1.html",l:-1,t:"Interacting with the Space",i:0.000417854116928721,a:"Smart Cache Interacting with the Space In this part of the tutorial we will demonstrate how to create a space and how you can interact with it. We will also demonstrate how you can improve your space search performance by using indexes and returning partial results. Creating a Space Let\u0027s create a ..."},"8":{y:0,u:"../started/data-partitioning.html",l:-1,t:"Data Partitioning",i:0.000849402359100896,a:"Smart Cache Smart DIH Data Partitioning   Data Partitioning (load balancing) is essential for any truly scalable architecture, as it enables scaling beyond the physical resources of a single-server machine. It is optimal to spread large amounts of data across multiple JVMs (Java Virtual Machines) ..."},"9":{y:0,u:"../started/xap-tutorial-part2.html",l:-1,t:"Deploying a Space",i:0.000365918342101923,a:"Smart Cache Deploying a Space In the previous section you have learned about data grid\u0027s capabilities as a data store. In this part of the tutorial we will show you how you can deploy an In Memory Data Grid (IMDG) that provides scalability and failover. Data gridcan be used as a scalable application ..."},"10":{y:0,u:"../started/xap-tutorial-part3.html",l:-1,t:"Distributed Processing",i:0.000365918342101923,a:"Smart Cache Distributed Processing In this part of the tutorial we will introduce you to the different processing services you can run on top of the space. Data grid includes a set of built-in service components such as Task Execution and Messaging services, each implementing commonly used ..."},"11":{y:0,u:"../started/xap-tutorial-part4.html",l:-1,t:"Event-Driven Programming",i:0.00040914774141421,a:"Smart Cache Event-Driven Programming The Space\u0027s Messaging and Events support provides messaging handlers that simplify event driven programming. Events are generated when objects are written, updated or taken from the space. With this framework you select events based on its content and designate a ..."},"12":{y:0,u:"../started/xap-tutorial-part5.html",l:-1,t:"Creating a Processing Unit",i:0.000365918342101923,a:"Smart Cache Creating a Processing Unit The PU is the fundamental unit of deployment in data grid. The PU itself runs within a Processing Unit Container and is deployed onto the Service Grid. Once a PU is deployed, a PU instance is the actual runtime entity. There are two types of Processing Unit ..."},"13":{y:0,u:"../started/xap-tutorial-part6.html",l:-1,t:"Transactions and Concurrency",i:0.000365918342101923,a:"Smart Cache Transactions and Concurrency In this part of the tutorial we will introduce you to the transaction processing capabilities of GigaSpaces. The Spring Framework provides a transaction manager abstraction using the PlatformTransactionManager interface with several different built-in ..."},"14":{y:0,u:"../started/xap-tutorial-part7.html",l:-1,t:"Persist to Database",i:0.000430602230590532,a:"Smart Cache Persist to Database There are many situations where space data needs to be persisted to permanent storage and retrieved from it. For example: Our online payment system works primarily with the memory space for temporary storage of process data structures, and the permanent storage is ..."},"15":{y:0,u:"../started/xap-tutorial-part8.html",l:-1,t:"Deploy a Web App",i:0.000365918342101923,a:"Smart Cache Deploy a Web App In this part of the tutorial we will show you how you can deploy a standard WAR file onto the Service Grid. GigaSpaces allows you to deploy web applications (packaged as a WAR file) onto the Service Grid. The integration is built on top of the Service Grid Processing ..."},"16":{y:0,u:"../security/security-overview.html",l:-1,t:"Security Overview",i:0.0036752641059319,a:"Smart Cache Smart DIH Security Overview For both Service Grid and Kubernetes Orchestration, Security is made up of Authentication and Authorization. Security provides comprehensive support for securing your data and services. Authentication Authentication is the process of establishing and ..."},"17":{y:0,u:"../started/xap-tutorial-part10.html",l:-1,t:"Security for Smart Cache Service Grid",i:0.000429549826577953,a:"Smart Cache Security for Smart Cache Service Grid This is an introduction to data grid security, where it fits in the data grid architecture, which components can be secured, and how to configure and customize the security depending on your application security requirements.\nData grid Security ..."},"18":{y:0,u:"../started/blobstore.html",l:-1,t:"Multi-Tiered Data Storage (SSD)",i:0.000365918342101923,a:"GigaSpaces 10 introduced a new storage model called BlobStore Storage Model, which allows an external storage medium (one that does not reside on the JVM heap) to store the IMDG data. This guide describes the general architecture and functionality of this storage model that is leveraging both ..."},"19":{y:0,u:"../started/xap-junit.html",l:-1,t:"JUnit Testing",i:0.000365918342101923,a:"Smart Cache JUnit Testing When creating unit tests with data grid you will use an Embedded Space that is internally represented by the IntegratedProcessingUnitContainer class and a reference to this Space will be available through a class implementing the GigaSpace interface. This allows you to read ..."},"20":{y:0,u:"../started/xap-debug.html",l:-1,t:"Debugging a GigaSpaces-Based Application",i:0.00325556993660065,a:"Smart Cache Debugging a GigaSpaces-Based Application Testing and Debugging the Processing Unit As part of your development process, you may want to run/debug your processing unit within your IDE, or create unit tests (with JUnit for example) to tests in isolation certain aspects of it. The ..."},"21":{y:0,u:"../started/insightedge-basics.html",l:-1,t:"Analytics Basics",i:0.000478154061244961,a:"The GigaSpaces Platform is a first-class integration between Apache Spark and the GigaSpaces data grid. This integration co-locates Spark jobs with the data they need to access, providing ultra-low latency and high-throughput transaction and stream processing. GigaSpaces simplifies and streamlines ..."},"22":{y:0,u:"../started/insightedge-in-5-minutes.html",l:-1,t:"GigaSpaces in 5 Minutes",i:0.000443676736594185,a:"This topic describes how to start an GigaSpaces using the embedded demo, in order to get you up and running as quickly as possible. The demo is launched via the GigaSpaces command line interface (CLI) tool. The GigaSpaces demo runs in standalone mode and creates the following environment on your ..."},"23":{y:0,u:"../started/memory-extend-getting-started.html",l:-1,t:"Getting Started with MemoryXtend",i:0.000365918342101923,a:" In a traditional deployment, all data grid entries are stored in RAM to provide the fastest performance possible. However, while RAM performs better than SSD, it is also more expensive. As SSD gains in popularity, we see new scenarios where storing part of the data in SSD and part in RAM provides ..."},"24":{y:0,u:"../started/insightedge-local-setup.html",l:-1,t:"Starting GigaSpaces on a Local Service Grid",i:0.00123606772921448,a:"This section explains how to start an GigaSpaces environment on a local machine. Prerequisites Before running GigaSpaces, verify that you have the following installed in your environment: Java 8 or 11 Scala 2.11 Maven 3.1+ Starting the Local Environment The GigaSpaces environment consists of Spark ..."},"25":{y:0,u:"../started/insightedge-zeppelin.html",l:-1,t:"Using the GigaSpaces Web Notebook",i:0.00198881623674813,a:"This section describes how to use the interactive Apache Zeppelin Web Notebook with GigaSpaces. Starting the Web Notebook The GigaSpaces Apache Zeppelin web notebook can be started in any of the following ways: Run the insightedge demo command; the web notebook is started automatically at  ..."},"26":{y:0,u:"../started/insightedge-examples.html",l:-1,t:"Running GigaSpaces IDE Examples",i:0.00068246177083063,a:"Overview This section explains how to use the sample code that has been provided with the GigaSpaces package. The example sources are located at  $GS_HOME/insightedge/examples. The example .jar file is located at  $GS_HOME/insightedge/examples/jars. Building the Examples Building the examples is not ..."},"27":{y:0,u:"../started/insightedge-first-app.html",l:-1,t:"Developing Your First Spark Application",i:0.00068246177083063,a:"This topic explains how to create an GigaSpaces application that can read and write from/to the Data Grid. You should have a basic knowledge of  Apache Spark . For instructions on how to install a minimum GigaSpaces cluster setup and launch it, refer to  Local Machine Setup . Project Dependencies ..."},"28":{y:0,u:"../dev-java/index.html",l:-1,t:"Developer Guide",i:0.000677248222492045,a:"The Developer section explains the key concepts and features that are used to build GigaSpaces and GigaSpaces applications. The topics in this section cover a wide range of information, such as GigaSpaces and GigaSpaces APIs, data modeling, indexing, memory management, Space replication, web ..."},"29":{y:0,u:"../dev-java/pojo-overview.html",l:-1,t:"POJO Support",i:0.00218784261667454,a:"Smart Cache POJO Support The GigaSpaces interface fully supports POJOs. In terms of preconditions, your POJO classes must follow the JavaBeans conventions (have a no-argument constructor) and declare a getter and setter to every field you want saved on the Space. The POJO class doesn\u0027t have to ..."},"30":{y:0,u:"../dev-java/dynamic-properties.html",l:-1,t:"Dynamic Properties",i:0.00237958597657468,a:"Smart Cache Dynamic Properties POJO entries properties are bound by the schema of the POJO class definition, which means a property cannot be added without changing the class, and since changing the class requires restarting the space this can be a long and tiresome project. Starting with version ..."},"31":{y:0,u:"../dev-java/document-overview.html",l:-1,t:"Space Document",i:0.00448951056117792,a:"Smart Cache Smart DIH Space Document The GigaSpaces document API exposes the space as  Document Store . A document, which is represented by the class SpaceDocument, is essentially collection of key-value pairs, where the keys are strings and the values are primitives, String, Date, other documents, ..."},"32":{y:0,u:"../dev-java/document-api.html",l:-1,t:"Document API",i:0.00740743733593045,a:"Smart Cache Smart DIH Document API Unlike POJOs, which force users to design a fixed data schema (in the form of a class definition) and adhere to it, a Document is much more dynamic - users can add and remove properties at runtime as necessary. A Document always belongs to a certain type, ..."},"33":{y:0,u:"../dev-java/document-extending.html",l:-1,t:"Extended Document",i:0.0023682009505711,a:"Smart Cache Smart DIH Extended Document While documents provide us with a dynamic schema, they force us to give up Java\u0027s type-safety for working with type less key-value pairs. GigaSpaces supports extending the SpaceDocument class to provide a type-safe wrapper for documents which is much easier to ..."},"34":{y:0,u:"../dev-java/document-pojo-interoperability.html",l:-1,t:"Interoperability",i:0.00224110475620639,a:"Smart Cache Interoperability GigaSpaces offers interoperability between documents and POJOs via the Space - it is possible to write POJOs and read them back as documents, and vice versa. This is usually useful in scenarios requiring reading and/or manipulating POJO objects without loading the ..."},"35":{y:0,u:"../dev-java/modeling-your-data.html",l:-1,t:"GigaSpaces Data Modeling",i:0.00394003536056942,a:"Smart Cache Smart DIH GigaSpaces Data Modeling What Kinds of Data Stores are Available in GigaSpaces? POJO is available, but in Smart DIH, by default, only  Space Document  is used. When a Data Store object is defined in GigaSpaces, the object can be defined as a  Space Object  or a  Space Document ..."},"36":{y:0,u:"../dev-java/space-object-id-operations.html",l:-1,t:"Space Object ID",i:0.000894679375691351,a:"Smart Cache Smart DIH Space Object ID POJO is available, but in Smart DIH, by default, only  Space Document  is used. How is the Space Object ID Generated? You can insert an object into the space using the write() and writeMultiple() methods. When a new object is inserted into the space, it embeds a ..."},"37":{y:0,u:"../dev-java/pojo-annotation-overview.html",l:-1,t:"Annotation-Based Metadata",i:0.000878933754814307,a:"Smart Cache Annotation-Based Metadata The GigaSpaces API supports class and property decorations with POJOs. These can be specified via annotations on the Space class source itself. You can define common behavior for all class instances, and specific behavior for class fields.   This topic includes ..."},"38":{y:0,u:"../dev-java/pojo-class-annotations.html",l:-1,t:"Class Annotations",i:0.000365918342101923,a:"Smart Cache Class Annotations The  GigaSpaces API  supports class level decorations with POJOs. These can be specified via annotations on the space class source itself  for all class instances. GigaSpaces provides the ability to obtain and modify class metadata of objects stored in the Space  during ..."},"39":{y:0,u:"../dev-java/pojo-attribute-annotations.html",l:-1,t:"Property Annotations",i:0.000381354259224376,a:"Smart Cache Property Annotations The  GigaSpaces API  supports  field-level decorations with POJOs. These can be specified via annotations on the Space class source itself. The annotations are defined on the getter methods. GigaSpaces provides the ability to obtain and modify class metadata of ..."},"40":{y:0,u:"../dev-java/pojo-xml-metadata-overview.html",l:-1,t:"XML-Based Metadata",i:0.000844374468373302,a:"Smart Cache XML-Based Metadata GigaSpaces provides the gs.xml Space mapping configuration file so you can define Space  class metadata  when using a POJO class with getter or setter methods. Space mapping files are also required when using POJO objects with the ExternalDataSource interface. The ..."},"41":{y:0,u:"../dev-java/pojo-xml-metadata-class.html",l:-1,t:"Class Metadata",i:0.000724790644890135,a:"Smart Cache Class Metadata GigaSpaces provides the ability to obtain and modify class metadata of objects stored in the Space  during runtime . Name Example: \u003cgigaspaces-mapping\u003e\n    \u003cclass name=\"model.Person\"\u003e\n    \u003c/class\u003e\n\u003c/gigaspaces-mapping\u003e\n Persistence Example: \u003cgigaspaces-mapping\u003e\n    \u003cclass ..."},"42":{y:0,u:"../dev-java/pojo-xml-metadata-attribute.html",l:-1,t:"Property Metadata",i:0.000724790644890135,a:"Smart Cache Property Metadata All the properties are written automatically into Space. If the field is a reference to another object, it has to be Serializable and it will be written into Space as well. Only the fields that need special space behavior need to be specified in the gs.xml file. Specify ..."},"43":{y:0,u:"../dev-java/pojo-grid-annotations.html",l:-1,t:"Grid Metadata",i:0.000632823116559651,a:"Smart Cache Grid Metadata GigaSpaceContext \n//There can be more than one GigaSpace instance defined\n\npublic class MyService {\n\n    @GigaSpaceContext(name=\"directGigaSpace\")\n    private GigaSpace directGigaSpace;\n\n    @GigaSpaceContext(name=\"clusteredGigaSpace\")\n    private GigaSpace ..."},"44":{y:0,u:"../dev-java/storage-types-controlling-serialization.html",l:-1,t:"Storage Types",i:0.00465971962406246,a:"Smart Cache Storage Types Each non-primitive space object property can be assigned a storage type decoration which determines how it is serialized and stored in the space. There are 3 storage types that are available: OBJECT, which means that the property will be stored as a regular Java object in ..."},"45":{y:0,u:"../dev-java/custom-serialization.html",l:-1,t:"Custom Serialization",i:0.00384486256847727,a:"Smart Cache Custom Serialization To solve the performance problems associated with class serialization, the serialization mechanism allows you to declare an embedded class is Externalizable. When the ObjectOutputStream writeObject() method is called, it performs the following sequence of actions: ..."},"46":{y:0,u:"../dev-java/lowering-the-space-object-footprint.html",l:-1,t:"Reducing the Space Object Footprint",i:0.000365918342101923,a:"Smart Cache Reducing the Space Object Footprint Overview By default, when using the GigaSpaces Java API, Space object fields are stored in the Space as is. No data compaction or compression is done while the object is transported across the network, or when stored within the Space. With the compact ..."},"47":{y:0,u:"../dev-java/the-gigaspace-interface-overview.html",l:-1,t:"The Space Interface",i:0.0109390505876878,a:"Smart Cache The Space Interface A Space is a logical in-memory service, which can store entries of information. An entry is a domain object. In Java, an entry can be a simple POJO, or a SpaceDocument. When a client connects to a Space, a proxy is created that holds a connection, which implements the ..."},"48":{y:0,u:"../dev-java/the-space-bean.html",l:-1,t:"The Space Bean",i:0.000381354259224376,a:"Smart Cache The Space Bean When a client connects to a space, a proxy is created that holds a connection to the space. All client interaction is performed through this proxy.\nThe proxy provides a simpler space API using the  GigaSpace  interface.\nIt can be created with a Space Bean and optional ..."},"49":{y:0,u:"../dev-java/the-space-configuration.html",l:-1,t:"The Space URL",i:0.00642305528396685,a:"Smart Cache The Space URL When a client connects to a space, a proxy is created that holds a connection to the space. All client interaction is performed through this proxy.\nThe proxy provides a simpler space API using the  GigaSpace  interface.\nIt is created with a Space URL and optional ..."},"50":{y:0,u:"../dev-java/the-space-operations.html",l:-1,t:"Operations",i:0.00209757160223165,a:"Smart Cache Operations GigaSpaces provides a simple Space API using the  GigaSpace  interface for interacting with the Space. The interface includes the following main operations: Reading objects from the Space: readById  from the Space readByIds  from the Space read  object by template from the ..."},"51":{y:0,u:"../dev-java/change-api-overview.html",l:-1,t:"Change API",i:0.000775956974024441,a:"Smart Cache Change API The  GigaSpace.change  and the  ChangeSet  allows updating existing objects in Space, by specifying only the required change instead of passing the entire updated object. Additional Resources The GigaSpace.change and the ChangeSet  allow updating existing objects in the Space, ..."},"52":{y:0,u:"../dev-java/change-api-custom-operation.html",l:-1,t:"Custom Change",i:0.00133770707033584,a:"Smart Cache Custom Change A custom change operation lets the user implement his own change operation in case the built-in operations (increment, add, remove, set, etc.) do not suffice. This is a very powerful capability but it must be used with extreme caution. Implementing and Using a Custom Change ..."},"53":{y:0,u:"../dev-java/the-space-no-restart.html",l:-1,t:"Changing Code without a Restart",i:0.00313874866575936,a:"Smart Cache Changing Code without a Restart The @SupportCodeChange annotation is used to tell the Space that your code has changed during runtime, affecting the Space task that needs to be executed. The Space can store multiple versions of the same task. This is useful in supporting client ..."},"54":{y:0,u:"../dev-java/change-api-advanced.html",l:-1,t:"Advanced Implementations",i:0.000675782586285369,a:"Smart Cache Advanced Implementations Change and SpaceSynchronizationEndpoint A SpaceSynchronizationEndpoint implementation can make use of the  Change API  and support change operation, this way allowing the network utilization to be more optimized by sending only the change set to the mirror ..."},"55":{y:0,u:"../dev-java/the-space-counters.html",l:-1,t:"Counters",i:0.000610454898403825,a:"Smart Cache Counters A growing number of applications such as real time ad impressions , ad optimization engines, social network , on-line gaming , need real-time counters when processing incoming streaming of events. The challenge is to update the counter in atomic manner without introducing a ..."},"56":{y:0,u:"../dev-java/aggregators.html",l:-1,t:"Aggregators",i:0.00392863057752409,a:"Smart Cache Aggregators Built-in Aggregators allow you to perform the entire aggregation activity at the space side avoiding any data retrieval back to the client side. Only the result of each aggregation activity performed with each partition is returned back to the client side where all the ..."},"57":{y:0,u:"../dev-java/the-space-transactions.html",l:-1,t:"Transactions",i:0.000365918342101923,a:"Smart Cache Transactions GigaSpace with the different GigaSpaces transaction managers  and Spring allow simple declarative definition of transactions. This boils down to the fact that if there is an ongoing transaction running, any operation performed using the GigaSpace interface joins it, using ..."},"58":{y:0,u:"../dev-java/the-space-notifications.html",l:-1,t:"Notifications",i:0.000739458205695999,a:"Smart Cache Notifications Some of the sSpace operations can generate notifications when they are executed. Notifications are also generated when working in clustered mode (schema) that includes a primary/backup schema. A listener can be defined to receive these notifications. The following Space ..."},"59":{y:0,u:"../dev-java/the-space-filters.html",l:-1,t:"Space Filters",i:0.000941996701396549,a:"Smart Cache Space Filters Space Filters are interceptors inside the GigaSpaces Space engine that enable integration with external systems and/or implementation of user-defined logic once space operations are executed. The UrlSpaceFactoryBean allows you to configure  Space Filters . It uses the space ..."},"60":{y:0,u:"../dev-java/the-space-filters-metadata.html",l:-1,t:"Interceptors",i:0.000632823116559651,a:"Smart Cache Interceptors The Space Filter implementation may use the following interceptors. The relevant method should be annotated with the annotation listed below. The signature of these methods may include the following parameters: Annotation List: The space filter business logic impacts the ..."},"61":{y:0,u:"../dev-java/space-mode-context-loader.html",l:-1,t:"Space Mode Context Loader",i:0.000981746960069375,a:"Smart Cache Space Mode Context Loader Most of the OpenSpaces built-in components take into account the state of the space (mainly applicable when starting an embedded space within the Processing Unit). This is important when working directly on a cluster member, since operations cannot be performed ..."},"62":{y:0,u:"../dev-java/leases-automatic-expiration.html",l:-1,t:"Lease Time",i:0.00315353743387876,a:"Smart Cache Lease Time In distributed applications on a network, where there may be partial failures of the network or of components, there needs to be a way for components to be timed out if they have failed, or have become unreachable. Lease is a basic mechanism GigaSpaces provides to address this ..."},"63":{y:0,u:"../dev-java/the-space-meta-data.html",l:-1,t:"Data Type Metadata",i:0.00439537421092871,a:"Smart Cache Data Type Metadata GigaSpaces provides the ability to obtain and modify class metadata of objects stored in the Space during runtime. Metadata Discovery The actual class names are discovered with the Admin interface  through the Space interface. import ..."},"64":{y:0,u:"../dev-java/querying-the-space.html",l:-1,t:"Querying the Space Using GigaSpaces API",i:0.00064155825620073,a:"Smart Cache Querying the Space Using GigaSpaces API This section explains the various mechanisms offered by GigaSpaces GigaSpaces to query the space for data: ID query  - Retrieve objects from the Space based on the Primary Key. Query by template  - Find data based on template matching (a.k.a. Match ..."},"65":{y:0,u:"../dev-java/query-by-id.html",l:-1,t:"Id Queries",i:0.00128021528764905,a:"Smart Cache Id Queries The space can be queried for entries using  Template Matching  or  SQLQuery , but sometimes we know the exact id of the entry we need and prefer a faster solution. This is where id-based queries come handy. Reading an Entry By ID When you would like to access an object using ..."},"66":{y:0,u:"../dev-java/query-template-matching.html",l:-1,t:"Template Matching",i:0.00225567419018949,a:"Smart Cache Template Matching Template matching (a.k.a. Match by example) is a simple way to query the space - The template is a POJO of the desired entry type, and the properties which are set on the template (i.e. not null) are matched against the respective properties of entries of the same type ..."},"67":{y:0,u:"../dev-java/query-sql.html",l:-1,t:"SQL Query API",i:0.01161505707207,a:"Smart Cache SQL Query API The SQLQuery class is used to query the Space using SQL-like syntax. The query statement includes only the WHERE statement part - the selection aspect of a SQL statement is embedded in other parameters for a SQL query.   For full ANSI SQL-99 support, see the  GigaSpaces ..."},"68":{y:0,u:"../dev-java/query-sql-function.html",l:-1,t:"SQL Functions",i:0.000426798759047895,a:"Smart Cache SQL Functions You can query the Space using built-in functions and user-defined functions. Built-In Functions For example, lets assume we have a class called Person with an Address property: @SpaceClass\npublic class Person  {\n    private UUID id;\n    private String firstName;\n    private ..."},"69":{y:0,u:"../dev-java/custom-matching.html",l:-1,t:"Custom Matching",i:0.000365918342101923,a:"Smart Cache Custom Matching Overview Queries are usually indexed and executed using primitive fields (long, float, string, etc.). These fields can be at the root level of the Space object, or embedded within  nested objects  in the Space object. You can construct a query using a template object or ..."},"70":{y:0,u:"../dev-java/query-geospatial.html",l:-1,t:"Geospatial Queries",i:0.002306098371778,a:"Smart Cache Geospatial Queries Spatial queries make use of geometry data types such as points, circles and polygons and these queries consider the spatial relationship between these geometries. Spatial queries can be used with any space operation which supports SQL queries (read, readMultiple, take, ..."},"71":{y:0,u:"../dev-java/query-free-text-search.html",l:-1,t:"Free Text Search",i:0.00158205399477498,a:"Smart Cache Free Text Search Regular Expressions You can query the space using the SQL like operator or  rlike - Java Regular Expression  Query syntax. When using the SQL like operator you may use the following:\n% - match any string of any length (including zero length)\n_ - match on a single ..."},"72":{y:0,u:"../dev-java/query-full-text-search.html",l:-1,t:"Full Text Search",i:0.00163622552673154,a:"Smart Cache Full Text Search GigaSpaces products provide full text search capability, leveraging the  Lucene  search engine library. The following features are supported: Keyword matching Search for phrase Wildcard matching Proximity matching Range searching Boosting a term Regular expressions Fuzzy ..."},});