define({"73":{y:0,u:"../dev-java/query-nested-properties.html",l:-1,t:"Nested Properties in Space Objects",i:0.00119620543711264,a:"Smart Cache Nested Properties in Space Objects The  SQL Query  page shows how to express complex queries on flat Space entries (e.g. entries that are composed of scalar types like integers and strings), but in reality Space entries are often composed of more complex types.\nFor example, a Person ..."},"74":{y:0,u:"../dev-java/query-user-defined-classes.html",l:-1,t:"User Defined Classes",i:0.000411362841925442,a:"Smart Cache User Defined Classes Since matching and comparing expressions is executed via java\u0027s built-in equals and Comparable mechanisms, a user defined class can be matched and compared as well. For example, suppose a user defined a class called Version, which encapsulates a major version and a ..."},"75":{y:0,u:"../dev-java/query-paging-support.html",l:-1,t:"Paging Support with the Space Iterator API",i:0.00154795018527858,a:"Smart Cache Paging Support with the Space Iterator API If a collection of entries must be returned from the Space, this is usually carried out using one of the  readMultiple  overloads in GigaSpace. However, if there are a lot of matching entries, you may encounter several problems: Memory usage - ..."},"76":{y:0,u:"../dev-java/query-paging-support-old.html",l:-1,t:"Paging Support - GSIterator",i:0.000740313290726821,a:"The GSIterator was deprecated in XAP release 10.1 and will be removed in a future release. The  IteratorBuilder  with the  GSIterator   provides the ability to exhaustively read through all of the objects from the space that match one or more SQLQuery/templates. There are scenarios where the ..."},"77":{y:0,u:"../dev-java/query-partial-results.html",l:-1,t:"Projection",i:0.00159004737811691,a:"Smart Cache Projection In some cases, when querying the Space for Objects, only certain properties of those Objects are required (a.k.a. delta read). The same scenario is also relevant when subscribing for notifications on Space data changes, where only specific properties are of interest to the ..."},"78":{y:0,u:"../dev-java/query-explainplan.html",l:-1,t:"Explain Plan",i:0.000411362841925442,a:"Smart Cache Explain Plan Explain Plan can be used to obtain a description of the strategy or plan that GigaSpaces uses to implement a specific SQLQuery.\nExplain Plan reports on the way in which the query uses indices and how many entries were scanned. For detailed information how to assign indexes, ..."},"79":{y:0,u:"../dev-java/indexing-overview.html",l:-1,t:"Indexing",i:0.00450332300981878,a:"Smart Cache Smart DIH Indexing When a Space is looking for a match for a read or take operation, it iterates over non-null values in the template, looking for matches in the Space. This process can be time consuming, especially when there are many potential matches. To improve performance, it is ..."},"80":{y:0,u:"../dev-java/indexing.html",l:-1,t:"Space Index",i:0.00226821958456412,a:"Smart Cache Smart DIH Space Index Index Types The index type is determined by the SpaceIndexType enumeration. The index types are: NONE - No indexing is used. EQUAL - performs equality matching (equal to/not equal to). ORDERED - performs ordered matching (bigger than/less than). EQUAL_AND_ORDERED - ..."},"81":{y:0,u:"../dev-java/indexing-nested-properties.html",l:-1,t:"Nested Property Index",i:0.00110819975916449,a:"An index can be defined on a nested property to improve performance of nested queries - this is highly recommended.\nNested properties indexing uses an additional @SpaceIndex attribute - path(). The SpaceIndex.path() Attribute The path() attribute represents the path of the property within the nested ..."},"82":{y:0,u:"../dev-java/indexing-collections.html",l:-1,t:"Collection Index",i:0.00137724516395615,a:"Smart Cache Collection Index An index can be defined on a Collection property (java.util.Collection implementation) or Array. Setting such an index means that each of the Collection\u0027s or Array\u0027s items is indexed. Setting an index on a Collection / Array done using the SpaceIndex.path() attribute ..."},"83":{y:0,u:"../dev-java/indexing-compound.html",l:-1,t:"Compound Index",i:0.00169047997246518,a:"Smart Cache Compound Index GigaSpaces supports compound indexing, where a single index structure holds references to multiple fields within objects stored within the Space.\nA compound index should be used to speed up queries that match on multiple fields with AND conditions between them. Maintaining ..."},"84":{y:0,u:"../dev-java/indexing-geospatial.html",l:-1,t:"Geospatial Index",i:0.00189412066215172,a:"Smart Cache Geospatial Index Geospatial indexes can be defined by using the @SpaceSpatialIndex and @SpaceSpatialIndexes annotations. Lets assume we have a class called GasStation that has a Point property that describes its location and we want to execute geospatial queries\nagainst this property: ..."},"85":{y:0,u:"../dev-java/indexing-text-search.html",l:-1,t:"Text Search Index",i:0.000721628563063762,a:"Smart Cache Text Search Index Text Search indexes can be defined by using the @SpaceTextIndex and @SpaceTextIndexs annotations. Lets assume we have a class called NewsArticle that has a content property that describes text we want to execute the text search queries\nagainst: import ..."},"86":{y:0,u:"../dev-java/indexing-unique.html",l:-1,t:"Unique Index",i:0.000365918342101923,a:"Smart Cache Unique Index Unique constraints can be defined for an attribute or attributes of a space class. This will ensure that only one instance of the space class exists in the space with the specific attribute value. These indexes are applicable to all types of index; Equal, Ordered, ..."},"87":{y:0,u:"../dev-java/transaction-overview.html",l:-1,t:"Transactions",i:0.00662383541108567,a:"Smart Cache Transactions The Spring Framework provides a transaction manager abstraction using the PlatformTransactionManager interface with several different built-in implementations, such as JDBC Data Source and JTA. GigaSpaces provides several implementations for Spring\u0027s ..."},"88":{y:0,u:"../dev-java/transaction-locking-and-blocking.html",l:-1,t:"Locking and Blocking",i:0.000989618697133904,a:"Smart Cache Locking and Blocking Locking of objects occurs in multi-user systems to preserve the integrity of changes, so that changes made by one process do not accidentally overwrite changes made by another process.\nGigaSpaces provides two strategies for locking objects: Optimistic and ..."},"89":{y:0,u:"../dev-java/transaction-read-modifiers.html",l:-1,t:"Read Modifiers",i:0.000733747988149433,a:"Smart Cache Read Modifiers GigaSpaces ReadModifiers class (see  Javadoc ) provides static methods and constants to decode read-type modifiers. The sets of modifiers are represented as integers with distinct bit positions representing different modifiers. Four main types of modifiers can be used: ..."},"90":{y:0,u:"../dev-java/transaction-optimistic-locking.html",l:-1,t:"Optimistic Locking",i:0.00108042003497146,a:"Smart Cache Optimistic Locking With optimistic locking, you write your business logic allowing multiple users to read the same object at the same time, but allow only one user to update the object successfully. The assumption is that there will be a relatively large number of users trying to read ..."},"91":{y:0,u:"../dev-java/transaction-pessimistic-locking.html",l:-1,t:"Pessimistic Locking",i:0.000404797539348054,a:"Smart Cache Pessimistic Locking The pessimistic locking protocol provides data consistency in a multi user transactional environment. It should be used when there might be a large number of clients trying to read and update the same object(s) at the same time. This protocol utilize the system ..."},"92":{y:0,u:"../dev-java/persistency-for-a-database.html",l:-1,t:"Persistency ",i:0.013074361349655,a:"Smart Cache Persistency  Space persistency in GigaSpaces is comprised of two components, a Space data source and a Space synchronization endpoint. These components provide advanced persistency capabilities for the Space architecture to interact with a persistency layer, and are in charge of the ..."},"93":{y:0,u:"../dev-java/direct-persistency.html",l:-1,t:"Direct Persistency",i:0.00511749231413034,a:"Smart Cache Direct Persistency When running in direct persistency mode (i.e. Read-Write Through) the data grid interacts with the data source to persist its data where the client application would get the acknowledge for the data grid operation only after both the data grid and the SpaceDataSource ..."},"94":{y:0,u:"../dev-java/hibernate-space-persistency.html",l:-1,t:"Hibernate Integration",i:0.00832281570793403,a:"Smart Cache Hibernate Integration GigaSpaces comes with a built in implementation of  Space Persistency  APIs for Hibernate. This implementation is an extension of the SpaceDataSource and SpaceSynchronizationEndpoint classes. The implementation allows a custom objects persistency using Hibernate ..."},"95":{y:0,u:"../dev-java/space-data-source-api.html",l:-1,t:"Data Source",i:0.0050678596181554,a:"Smart Cache Data Source The  SpaceDataSource  is used by the Space for interacting with the persistency layer in two cases: Initial data \u0026 meta data loading from a data source (i.e. a database). In LRU mode, when the space needs to read data from the data source (cache miss as a result of ..."},"96":{y:0,u:"../dev-java/space-synchronization-endpoint-api.html",l:-1,t:"Synchronization Endpoint",i:0.00765988777942015,a:"Smart Cache Synchronization Endpoint The  SpaceSynchronizationEndpoint  is used for persisting data from the space to an external storage.\nThe following data is synchronized: Batched write/update/remove operations. Transactions. Dynamic index creation. Data type introduction. The space ..."},"97":{y:0,u:"../dev-java/space-persistency-initial-load.html",l:-1,t:"Initial Load",i:0.00525200010916606,a:"Smart Cache Initial Load The GigaSpaces Data Grid includes special interceptor that allow users to pre-load the Data-Grid with data before it is available for clients access. This interceptor called Initial Load and has a default implementation that is using the  Hibernate Space Persistency  ..."},"98":{y:0,u:"../dev-java/asynchronous-persistency-with-the-mirror.html",l:-1,t:"Asynchronous Persistency - Mirror Service",i:0.00784378950552148,a:"Smart Cache Asynchronous Persistency - Mirror Service The GigaSpaces Mirror Service (write behind) provides reliable asynchronous persistency which allows you to asynchronously delegate the operations conducted with the In-Memory-Data-Grid (IMDG) into a backend database, significantly reducing the ..."},"99":{y:0,u:"../dev-java/async-persistency-mirror-advanced.html",l:-1,t:"Advanced Mirror Configuration",i:0.00327716862424018,a:"Smart Cache Advanced Mirror Configuration Custom Mirror Service Name A Mirror Service can be configured per Space cluster. You can\u0027t have multiple Mirror services configured for the same space cluster. If you need \"multiple mirrors\" for the same space cluster you can implement a Mirror Service that ..."},"100":{y:0,u:"../dev-java/archive-container.html",l:-1,t:"Archive Container",i:0.00113102670855383,a:"Smart Cache Archive Container The archive container is used to transfer historical data into Big-Data storage (for example Cassandra). The typical scenario is when streaming vast number of raw events through the Space, enriching them and then moving them to a Big-Data storage. Typically, there is no ..."},"101":{y:0,u:"../dev-java/cassandra.html",l:-1,t:"Cassandra Integration",i:0.000464656739514328,a:"Smart Cache Cassandra Integration This is a reference implementation of integrating Cassandra with GigaSpaces for persistency and data reload.\nGigaSpaces does not guarantee up-to-date upgrades or support of the target NoSQL store drivers.\nWe encourage users to extend the  open source implementation  ..."},"102":{y:0,u:"../dev-java/cassandra-space-persistency.html",l:-1,t:"Cassandra Persistency",i:0.00197950916803618,a:"Smart Cache Cassandra Persistency GigaSpaces comes with built in implementations of  Space Data Source  and  Space Synchronization Endpoint  for Cassandra, called CassandraSpaceDataSource and CassandraSpaceSynchronizationEndpoint, respectively. For further details about the persistency APIs used see ..."},"103":{y:0,u:"../dev-java/cassandra-space-data-source.html",l:-1,t:"Data Source",i:0.000704452211017241,a:"Smart Cache Data Source A Cassandra based implementation of the  Space Data Source . Library dependencies The Cassandra Space Data Source uses  Cassandra JDBC Driver  and  Hector Library  when interacting with the Cassandra cluster.\ninclude the following in your pom.xml \u003c!-- currently the ..."},"104":{y:0,u:"../dev-java/cassandra-space-synchronization-endpoint.html",l:-1,t:"Synchronization Endpoint",i:0.00132197329650787,a:"Smart Cache Synchronization Endpoint A Cassandra based implementation of the  Space Synchronization Endpoint . Library dependencies The Cassandra Space Synchronization Endpoint uses the  Hector Library  For communicating with the Cassandra cluster.\nInclude the following in your pom.xml \u003cdependency\u003e\n ..."},"105":{y:0,u:"../dev-java/cassandra-hector-client.html",l:-1,t:"Hector Client",i:0.000796539647023772,a:"Smart Cache Hector Client A wrapper around the  Hector Library  used for communicating with Cassandra. This component is used by both the  Cassandra Space Synchronization Endpoint  and the  Cassandra Space Data Source . The main usage is related to metadata operations (such as creating column ..."},"106":{y:0,u:"../dev-java/cassandra-archive-operation-handler.html",l:-1,t:"Archive Handler",i:0.000659638602590129,a:"Smart Cache Archive Handler The  Archive Container  can be configured to work against Cassandra (without writing any extra code). The  ArchiveOperationHandler interface  abstracts the Big-Data storage from the  Archive Container . The Cassandra Archive Operation Handler implements this interface by  ..."},"107":{y:0,u:"../dev-java/mongodb.html",l:-1,t:"MongoDB Integration",i:0.00135788558408338,a:"Smart Cache MongoDB Integration This is a reference implementation of integrating MongoDB with GigaSpaces for persistency and data reload. GigaSpaces does not guarantee up-to-date upgrades or support of the target NoSQL store drivers. We encourage users to extend the open source implementation to ..."},"108":{y:0,u:"../dev-java/mongodb-space-persistency.html",l:-1,t:"Mongo Persistency",i:0.000365918342101923,a:"Smart Cache Mongo Persistency GigaSpaces comes with built in implementations of  Space Data Source  and  Space Synchronization Endpoint \n for MongoDB, called MongoSpaceDataSource and MongoSpaceSynchronizationEndpoint, respectively. For further details about the persistency APIs used see  Space ..."},"109":{y:0,u:"../dev-java/mongodb-space-data-source.html",l:-1,t:"Data Source",i:0.000365918342101923,a:"Smart Cache Data Source A MongoDB based implementation of the  Space Data Source . Library dependencies The MongoDB Space Data Source uses  MongoDB Driver  For communicating with the MongoDB cluster. include the following in your pom.xml     \u003c!-- currently the MongoDB library is not the central ..."},"110":{y:0,u:"../dev-java/mongodb-space-synchronization-endpoint.html",l:-1,t:"Synchronization Endpoint",i:0.000469596201424939,a:"Smart Cache Synchronization Endpoint A MongoDB based implementation of the  Space Synchronization Endpoint . Library dependencies The MongoDB Space Synchronization Endpoint uses the  MongoDB Driver  For communicating with the MongoDB cluster.\nInclude the following in your pom.xml     \u003c!-- currently ..."},"111":{y:0,u:"../dev-java/mongodb-archive-operation-handler.html",l:-1,t:"Archive Handler",i:0.000472738822021344,a:"Smart Cache Archive Handler The  Archive Container  can be configured to work against MongoDB (without writing any extra code). The  ArchiveOperationHandler interface  abstracts the Big-Data storage from the  Archive Container . The MongoDB Archive Operation Handler implements this interface by ..."},"112":{y:0,u:"../dev-java/transient-entries.html",l:-1,t:"Transient Entries",i:0.00167376052680678,a:"Smart Cache Transient Entries When using a persistent space there are situations where not all the space objects need to be persistent (saved within the database). You can specify a space Object to be stored only in the space, without storing it also in the persistent store, by setting its persist ..."},"113":{y:0,u:"../dev-java/space-persistency-advanced-topics.html",l:-1,t:"Advanced Topics",i:0.00258131931285502,a:"Smart Cache Advanced Topics This sections covers advanced options related to Space Persistency. Properties Here are the Space Persistency Properties: Troubleshooting To enable Space Persistency logging, edit the  $GS_HOME\\config\\log\\xap_logging.properties file, and set the persistent level to CONFIG ..."},"114":{y:0,u:"../dev-java/persistency-migrating-hibernate.html",l:-1,t:"Migrating from Hibernate",i:0.000365918342101923,a:"To benefit from data caching and other capabilities, it is worthwhile to migrate a legacy application that uses the Hibernate API, to the GigaSpace or GigaMap API. In such cases, these applications can benefit from the ability to scale when using the GigaSpaces Data Grid. This is achieved by ..."},"115":{y:0,u:"../dev-java/migrating-from-external-data-source-api.html",l:-1,t:"Migrating From External Data Source API",i:0.000365918342101923,a:"This page describes how EDS implementations prior to GigaSpaces version 9.5 should migrate to the new Space Persistency APIs. External Data Source API contains 5 interfaces the implementation can use: ManagedDataSource - base interface which provides the ability to initial load data from the data ..."},"116":{y:0,u:"../dev-java/memory-management-overview.html",l:-1,t:"Cache Policy",i:0.00462688004099238,a:"The GigaSpaces cache policy is used to prevent situations where a Space server gets into an out-of-memory failure scenario. Based on the configured cache policy, the memory manager protects the Space (and the application, if it is running co-located with the Space) from consuming memory beyond a ..."},"117":{y:0,u:"../dev-java/all-in-cache-cache-policy.html",l:-1,t:"ALL IN CACHE Policy",i:0.00151385140001248,a:"When running in ALL_IN_CACHE cache policy mode, the space uses only the available physical memory. When running in a persistent space mode and having  Space Persistency  defined, the space data is backed with the underlying database, but the overall capacity of the space does not exceed the capacity ..."},"118":{y:0,u:"../dev-java/lru-cache-policy.html",l:-1,t:"LRU Cache Policy",i:0.00515567458529814,a:"When running in LRU cache policy mode, the space evicts the \"oldest\" objects from its memory. \"Oldest\" objects are determined by the time they were written, updated or read in the space. In a persistent space mode, evicting a space object means that a space object is  simply be removed from the ..."},"119":{y:0,u:"../dev-java/custom-eviction-policy.html",l:-1,t:"Custom Eviction Policy",i:0.000381354259224376,a:"To manage the eviction activity when running in LRU cache policy mode, you can use the Custom eviction policy API. Configuring an LRU cache means you should be able to estimate certain characteristics of the in-memory data grid activity, such as the maximum frequency of the number of newly added ..."},"120":{y:0,u:"../dev-java/dep-intelligent-tiering-intro.html",l:-1,t:"Intelligent Tiered Storage",i:0.000365918342101923,a:"Overview In a traditional deployment, all data grid entries are stored in JVM heaps to provide the fastest performance possible. However, as the repository of data grows and grows, the following issues can arise: Cost - While RAM performs much better than a hard drive, it is also much more ..."},"121":{y:0,u:"../admin/memoryxtend-overview.html",l:-1,t:"Tiered Storage with MemoryXtend",i:0.00336401953872833,a:"Smart Cache Tiered Storage with MemoryXtend The MemoryXtend (blobstore) storage model allows an external storage medium (one that does not reside on the JVM heap) to store the Space data. This section describes the general MemoryXtend architecture and functionality, and its off-heap RAM, hSSD, and ..."},"122":{y:0,u:"../admin/memoryxtend-rocksdb-ssd.html",l:-1,t:"MemoryXtend for Disk (SSD/HDD)",i:0.00104557289463623,a:"Smart Cache MemoryXtend for Disk (SSD/HDD) MemoryXtend is NOT supported in Kubnernetes Orchestration Installations Overview The MemoryXtend disk storage driver delivers built-in, high-speed persistence that leverages local or attached SSD devices, all-flash-arrays (AFA), or any other disk or memory ..."},"123":{y:0,u:"../admin/memoryxtend-ohr.html",l:-1,t:"MemoryXtend for Off-Heap RAM",i:0.000896607469952868,a:"Smart Cache MemoryXtend for Off-Heap RAM MemoryXtend is NOT supported in Kubnernetes Orchestration Installations Overview The MemoryXtend off-heap storage driver stores Space objects in RAM, outside the Java heap. This has two benefits: Better RAM utilization - Objects are stored off-heap in ..."},"124":{y:0,u:"../admin/memoryxtend-pmem.html",l:-1,t:"MemoryXtend for PMEM",i:0.000896607469952868,a:"Smart Cache MemoryXtend for PMEM Overview Persistent Memory (PMEM) is a new class of memory that combines high capacity and affordability. By expanding affordable system memory capacities (greater than 3TB per CPU socket), end customers can use systems enabled with PMEM to better optimize their ..."},"125":{y:0,u:"../dev-java/other-data-access-apis.html",l:-1,t:"Data Access APIs",i:0.00039128830637601,a:"Smart Cache Data Access APIs GigaSpaces promotes openness and interoperability, supporting common interfaces for accessing data, such as JPA, Document, SQL, JDBC, Memcached, Spring Data and a native POJO-based API. You can choose the best API for the case at hand, and be able to operate on the same ..."},"126":{y:0,u:"../dev-java/jdbc-driver.html",l:-1,t:"JDBC V1 Driver - In-Memory Data Grid",i:0.0028886572957259,a:"Smart Cache JDBC V1 Driver - In-Memory Data Grid The GigaSpaces JDBC interface allows database-driven applications to interact with Spaces via SQL queries and commands. A query processor transparently translates SQL queries into legal Space operations. No integration is required - all you need to do ..."},"127":{y:0,u:"../dev-java/jpa-api-overview.html",l:-1,t:"JPA API",i:0.000435758301089024,a:"Smart Cache JPA API The Java Persistency API (JPA) is a Java-programming language framework that manages relational data in applications using the Java platform. GigaSpaces\u0027s JPA API allows you to use the JPA\u0027s functionality and annotations, and to execute JPQL queries on a Space. GigaSpaces\u0027s JPA ..."},"128":{y:0,u:"../dev-java/jpa-entity-id.html",l:-1,t:"JPA Entity ID",i:0.000418832412855686,a:"Smart Cache JPA Entity ID Download the Smart DIH Product Overview here \u003e\u003e Various options for mapping the identifier property of your JPA entities are provided. User-Defined Id In this case, the Entity\u0027s Id must be set manually in the user code before attempting to persist the entity. Reminder: ..."},"129":{y:0,u:"../dev-java/jpa-relationships.html",l:-1,t:"JPA Relationships",i:0.000418832412855686,a:"Smart Cache JPA Relationships The GigaSpaces JPA relationships model is different than Relational Databases model. In GigaSpaces relationships are owned, which means that an owner of a relationship holds the owned entities within itself in Space. For instance, if an Author has a One-to-many ..."},"130":{y:0,u:"../dev-java/jpa-limitations.html",l:-1,t:"Limitations",i:0.000418832412855686,a:"Smart Cache Limitations Functionalities that are not supported by the GigaSpaces JPA API. Annotations Here\u0027s a list of JPA annotations which are not supported by GigaSpaces JPA Access(AccessType.FIELD) JoinColumn Version UniqueConstraint Temporal AssociationOverride AttributeOverride ColumnResult ..."},"131":{y:0,u:"../dev-java/map-api.html",l:-1,t:"Map API",i:0.0022268417924593,a:"GigaSpaces allows applications to interact with the space and cache data using the Map API (JCache) or a  HashTable API . Accessing the space via the Map API can be done using the  GigaMap  interfaces. It includes enhanced options such as declarative transactions support, coherent runtime exception ..."},"132":{y:0,u:"../dev-java/memcached-api.html",l:-1,t:"Memcached API",i:0.000543725671844212,a:"Download the Smart DIH Product Overview here \u003e\u003e Memcached  is a popular caching protocol and server. The integration provided allows to use GigaSpaces as a memcached server (talking the memcached protocol) enhancing the memcached to provide high availability, write behind, and all the other features ..."},"133":{y:0,u:"../dev-java/client-side-caching.html",l:-1,t:"Client-Side Caching",i:0.00190606062374441,a:"Smart Cache Client-Side Caching GigaSpaces supports client-side caching of Space data within the client application\u0027s JVM. When using client-side caching, the user essentially uses a two-layer cache architecture: The first layer is stored locally, within the client\u0027s JVM, and the second layer is ..."},"134":{y:0,u:"../dev-java/local-cache.html",l:-1,t:"Local Cache",i:0.00496375952686877,a:"Smart Cache Local Cache A Local Cache is a client-side cache that maintains a subset of the master Space\u0027s data based on the client application\u0027s recent activity. The local cache is created empty, and whenever the client application executes a query the local cache first tries to fulfill it from the ..."},"135":{y:0,u:"../dev-java/local-view.html",l:-1,t:"Local View",i:0.00306423665866722,a:"Smart Cache Local View A local view is a read-only, client-side Space that maintains a subset of the master Space\u0027s data, allowing the client to read distributed data without performing any remote calls or data serialization. Data is streamed into the client application\u0027s local view based on ..."},"136":{y:0,u:"../dev-java/client-side-caching-over-the-wan.html",l:-1,t:"Caching over the WAN",i:0.000365918342101923,a:"Smart Cache Caching over the WAN   A common use case of the local cache or the local view is with remote geographical sites where most of the activities are read only. In this case each site may use an application server or a web application running a local view/cache caching a subset of the data or ..."},"137":{y:0,u:"../dev-java/monitoring-the-client-side-cache.html",l:-1,t:"Using JConsole to Monitor the Client-Side Cache Activity",i:0.000365918342101923,a:"Smart Cache Using JConsole to Monitor the Client-Side Cache Activity The Local View/Cache JMX Monitor monitors the number of objects stored within the client side cache and the activities performed with it. You can use  JConsole  to graph the number of objects within the local view/cache and other ..."},"138":{y:0,u:"../dev-java/task-execution-overview.html",l:-1,t:"Task Execution",i:0.00480410727719705,a:"Smart Cache Task Execution GigaSpaces supports Task execution in an asynchronous manner, co-located with the Space (Processing Unit that started an embedded Space). Tasks can be executed directly on a specific cluster member using routing declarations. Tasks can also be executed in \"broadcast\" mode ..."},"139":{y:0,u:"../dev-java/task-dynamic-language.html",l:-1,t:"Dynamic Language Tasks",i:0.000921098273185041,a:"Smart Cache Dynamic Language Tasks Event Driven Remoting  and  Executor Based Remoting  allow you to simply expose and execute custom services using the Space as the transport layer. The dynamic tasks feature (also known as \"scripting support\") allows you to utilize a built remote service, exposed ..."},"140":{y:0,u:"../dev-java/task-metadata.html",l:-1,t:"Metadata",i:0.000365918342101923,a:"Smart Cache Metadata Task Execution Example: public class MyTask implements Task\u003cInteger\u003e  {\n\n    @TaskGigaSpace\n    private transient GigaSpace colocatedSpace;\n    private transient GigaSpace clusteredSpace;\n\n    public MyTask() {\n    }\n....\n}\n Task Execution over the Space Task Routing Example: ..."},"141":{y:0,u:"../dev-java/storing-partition-information.html",l:-1,t:"Storing Partition Summary Information",i:0.000365918342101923,a:"Smart Cache Storing Partition Summary Information A scenario may occur where computation is done on a partition by partition basis and you wish to save the results, instead of recalculating them each time. This example calculates values per partition and saves it to the current partition. It will ..."},"142":{y:0,u:"../dev-java/event-processing.html",l:-1,t:"Event Processing",i:0.000712332351581565,a:"Smart Cache Event Processing This section describes the event processing APIs and how to configure them on top of the Space. The relevant APIs include the  Notify Container , which wraps the Space data event session API with event container abstraction, and the  Polling Container , which allows you ..."},"143":{y:0,u:"../dev-java/notify-container-overview.html",l:-1,t:"Notify Container",i:0.00812164602561333,a:"Smart Cache Notify Container The notify event container adopts the Space-inherited support for notifications (continuous query), using a GigaSpaces unified event session API. If a notification occurs, the  data event listener  is invoked with the event. A notify event operation is mainly used when ..."},"144":{y:0,u:"../dev-java/notify-container-transactions.html",l:-1,t:"Transaction Support",i:0.000365918342101923,a:"Smart Cache Transaction Support The notify container can be configured with transaction support, so the event action can be performed under a transaction. Exceptions thrown by the event listener cause the operations performed within the listener to be rolled back automatically. When using ..."},});